package net.saltymc.eaa.commands;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.CommandDispatcher;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import net.fabricmc.fabric.api.client.command.v1.ClientCommandManager;
import net.fabricmc.fabric.api.client.command.v1.FabricClientCommandSource;

public abstract class EaaModCommand implements Command<FabricClientCommandSource> {

    public EaaModCommand() {
        this(ClientCommandManager.DISPATCHER);
    }

    public EaaModCommand(CommandDispatcher<FabricClientCommandSource> dispatcher) {
        this.register(dispatcher);
    }

    public void register(CommandDispatcher<FabricClientCommandSource> dispatcher){
        dispatcher.register(this.getCommandSpecification());
    }

    public abstract LiteralArgumentBuilder<FabricClientCommandSource> getCommandSpecification();

}
